/*	one.h

	Complete internals for 1 process(or).

	December 1999 by Hank Dietz
*/


#ifndef _P_INTERN_H
#define _P_INTERN_H


#include <AFAPI/afapi.h>


/*	p__wait()...
*/

extern inline
void
p__wait(void)
{
	/* I'm here! */
}

/*	p__waitbar(), p__any(), and p__all()...
*/

extern inline
p_bar
p__waitbar(register p_1u f)
{
	return((p_bar) (f != 0));
}


extern inline
p_1u
p__any(register p_1u f)
{
	return((p_bar) (f != 0));
}


extern inline
p_1u
p__all(register p_1u f)
{
	return((p_bar) (f != 0));
}

/*	Inline signal primitives...
*/

extern inline void
s__signal(register int s)
{
	/* This is not worth inlining... */
	s_signal(s);
}


extern inline p_1u
s__pending(void)
{
	return(s_pending());
}


extern inline void
s__poll(void)
{
	if (s__pending()) s_signal(S_SIGANY);
}


extern inline void
s__wait(void)
{
	/* Just exit and re-enter... that flushes things */
	s_exit();
	s_init();
}


#endif
