/*	inline.h

	Wrapper to include the appropriate AFAPI internals for use
	in compiling with inline routines of these routines:

	p__wait()	p__waitbar()	p__any()	p__all()
	s__signal()	s__pending()	s__poll()	s__wait()

	Note: depending on the AFAPI family compiled for, some of these
	routines will not actually be inlined due to excessive code size.

	June 1998 by H. Dietz and T.I.Mattox
*/


#ifndef _P_INLINE_H
#define _P_INLINE_H

#include "../../src/" AFAPI "/intern.h"

#endif
