/*	vwtime.h

	Machine-dependent time constants
*/

/*	Empirical Intel processor clock ticks/second
	Approximate error: 0.000003%
*/
#define VWINTELTICKS 598846034.9

/*	Empirical worst-case seconds for usleep(1)
*/
#define VWUSLEEP1TIME 0.0200007186

/*	Empirical worst-case seconds for vwnow()
*/
#define VWNOWTIME 0.0000004575
